Skip to main content
GET
/
v1
/
wallets
/
{wallet_id}
/
actions
/
{action_id}
Get wallet action
curl --request GET \
  --url https://api.privy.io/v1/wallets/{wallet_id}/actions/{action_id} \
  --header 'Authorization: Basic <encoded-value>' \
  --header 'privy-app-id: <privy-app-id>'
HttpResponse<String> response = Unirest.get("https://api.privy.io/v1/wallets/{wallet_id}/actions/{action_id}")
.header("privy-app-id", "<privy-app-id>")
.header("Authorization", "Basic <encoded-value>")
.asString();
const options = {
method: 'GET',
headers: {'privy-app-id': '<privy-app-id>', Authorization: 'Basic <encoded-value>'}
};

fetch('https://api.privy.io/v1/wallets/{wallet_id}/actions/{action_id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
<?php

$curl = curl_init();

curl_setopt_array($curl, [
CURLOPT_URL => "https://api.privy.io/v1/wallets/{wallet_id}/actions/{action_id}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"Authorization: Basic <encoded-value>",
"privy-app-id: <privy-app-id>"
],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}
package main

import (
"fmt"
"net/http"
"io"
)

func main() {

url := "https://api.privy.io/v1/wallets/{wallet_id}/actions/{action_id}"

req, _ := http.NewRequest("GET", url, nil)

req.Header.Add("privy-app-id", "<privy-app-id>")
req.Header.Add("Authorization", "Basic <encoded-value>")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))

}
{
  "id": "cm7oxq1el000e11o8iwp7d0d0",
  "status": "pending",
  "wallet_id": "fmfdj6yqly31huorjqzq38zc",
  "type": "swap",
  "caip2": "eip155:1",
  "input_token": "native",
  "output_token": "0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48",
  "input_amount": null,
  "output_amount": null
}

Authorizations

Authorization
string
header
required

Basic Auth header with your app ID as the username and your app secret as the password.

Headers

privy-app-id
string
required

ID of your Privy app.

privy-authorization-signature
string

Request authorization signature. If multiple signatures are required, they should be comma separated.

Path Parameters

wallet_id
string
required

ID of the wallet.

action_id
string<uuid>
required

ID of the wallet action.

Query Parameters

include
enum<string>

Include step-level details in the response.

Available options:
steps

Response

200 - application/json

The wallet action with its current status.

Response for a swap action.

id
string
required

The ID of the wallet action.

status
enum<string>
required

The current status of the wallet action.

Available options:
pending,
succeeded,
rejected,
failed
wallet_id
string
required

The ID of the wallet involved in the action.

created_at
string<date-time>
required

ISO 8601 timestamp of when the wallet action was created.

type
enum<string>
required
Available options:
swap
caip2
string
required

CAIP-2 chain identifier for the swap.

input_token
string
required

Token address or "native" for the token being sold.

output_token
string
required

Token address or "native" for the token being bought.

input_amount
string | null
required

Exact base-unit amount of input token. Populated after on-chain confirmation.

output_amount
string | null
required

Exact base-unit amount of output token. Populated after on-chain confirmation.

failure_reason
FailureReason · object

Top-level failure context for the wallet action. Present on rejected or failed actions when available.

steps
(EVMTransactionWalletActionStep · object | EVMUserOperationWalletActionStep · object | SVMTransactionWalletActionStep · object | TVMTransactionWalletActionStep · object | ExternalTransactionWalletActionStep · object | CustodianTransactionWalletActionStep · object)[]

The steps of the wallet action. Only returned if ?include=steps is provided.

A wallet action step consisting of an EVM transaction.

destination_caip2
string

Destination chain CAIP-2 identifier. Present for cross-chain swaps.

destination_address
string

Recipient address on the destination chain. Present for cross-chain swaps. May differ from the source wallet address when swapping between chain types (e.g. EVM to Solana).

estimated_fees
(RelayerFee · object | PrivyFee · object | DeveloperFee · object)[] | null

Estimated fee breakdown from the provider quote. Only present for cross-chain swaps. Populated after on-chain confirmation.

Estimated fee paid to the relayer.

Example:
{
"type": "privy",
"recipient": "0x1234567890abcdef1234567890abcdef12345678",
"amount": "0.20"
}
estimated_gas
Gas · object | null

Estimated source-chain gas cost from the provider quote. Only present for cross-chain swaps. Populated after on-chain confirmation.

Example:
{
"base_amount": "100000000000000",
"amount": "0.0001",
"gas_asset": "ETH"
}
fees
(RelayerFee · object | PrivyFee · object | DeveloperFee · object)[] | null

Actual fees paid for the swap. Populated after on-chain confirmation. Only present for cross-chain swaps.

Estimated fee paid to the relayer.

Example:
{
"type": "privy",
"recipient": "0x1234567890abcdef1234567890abcdef12345678",
"amount": "0.20"
}
gas
Gas · object | null

Actual source-chain gas cost. Populated after on-chain confirmation. Only present for cross-chain swaps.

Example:
{
"base_amount": "100000000000000",
"amount": "0.0001",
"gas_asset": "ETH"
}